class HangmanBoard
{
    // instance variables
    private String answer;
    private String[] wordChoices;
    private char[] revealed; // if answer is "foobar" and we've guessed 'o' and 'a', stores "_oo_a_" as char[]
    private int wrongGuesses;
    private int maxWrongGuesses;
    private String guessedChars;

    // methods:
    // initialize
    // this week: just uses direct initialization; next week: from file!
    public void fillWordChoices()
    {
        String[] wc = {"using", "direct", "initialization"};
        wordChoices = wc;
    }

    // pick random word from wordChoices array
    public void chooseWord()
    {
        int a = (int) (wordChoices.length * Math.random());
        answer = wordChoices[a];
    }

    // initialize revealed to bunch of underscores
    public void makeBlanks()
    {
        revealed = new char[answer.length()];
ex        for(int i = 0; i < answer.length(); i++)
        {
            revealed[i] = '_';
        }
    }
    
    // picks different word, resets all variables
    public void refresh()
    {
        chooseWord();
        makeBlanks();
        wrongGuesses = 0;
        guessedChars = "";
    }
    
    // constructor
    // calls initializing methods
    public HangmanBoard()
    {
        maxWrongGuesses = 10; // this may change
        fillWordChoices();
        refresh();
    }

    // display
    // shows blanks (_oo_a_) and # guesses remaining
    public String toString()
    {
        String str = "";
        for (int i = 0; i < revealed.length; i++)
            str = str + revealed[i];
        str = str + "  -  " + (maxWrongGuesses - wrongGuesses) + " guesses remaining.";
        return str;
    }

    // for testing purposes
    public String getAnswer()
    {
        return answer;
    }

    // walk down revealed, looking for blanks
    public boolean hasWon()
    {
        for(int i = 0; i < answer.length(); i++)
        {
            if(revealed[i] == '_')
                return false;
        }
        return true;
    }

    // checks if wrong >= max
    public boolean hasLost()
    {
        return (wrongGuesses >= maxWrongGuesses);
    }


    // make a guess!
    // should update all variables (revealed, guessedChars, wrongGuesses)
    public boolean makeGuess(char c)
    {
        boolean inWord = false;
        guessedChars = guessedChars + c;

        for(int i = 0; i < answer.length(); i++)
        {
            if(answer.charAt(i) == c)
            {
                // insert c into the appropriate space in revealed
                revealed[i] = c;
                inWord = true;
            }
        }

        if(!inWord)
            wrongGuesses++;

        return inWord;
    }
}